//Mouse access functions

void Initialize_Mouse(void) {
   int t=0;
   asm {
      mov ax, 0
      int 33h
      mov t, ax
   }
   if (t == 0) {
      cout << "Mouse driver not found.\n";
      exit(0);
   }
   return;
}

void Show_Cursor(void) {
   asm {
      mov ax, 1
      int 33h
   }
}

void Hide_Cursor(void) {
   asm {
      mov ax, 2
      int 33h
   }
}

void Get_Mouse_Status(int &x, int &y, bool &button) {
   int x1, y1, buttons;
   asm {
      mov ax, 3
      int 33h
      mov x1, cx
      mov y1, dx
      mov buttons, bx
   }
   x = x1;
   y = y1;
   button = buttons & 0x01;
   return;
}

bool Mouse_Button(void) {
   int buttons;
   asm {
      mov ax, 3
      int 33h
      mov buttons, bx
   }
   return buttons & 0x01;
}

void Start_Mouse(void) {

   Initialize_Mouse();
   Show_Cursor();
   return;
}   

void Check_Mouse(int &x, int &y, bool &b) {
   Get_Mouse_Status(x,y,b);
   x /= 2;
   return;
}
